&ANALYZE-SUSPEND _VERSION-NUMBER UIB_v9r12
&ANALYZE-RESUME
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS Method-Library 
/*------------------------------------------------------------------------
    Library     : 
    Purpose     :

    Syntax      :

    Description :

    Author(s)   :
    Created     :
    Notes       :
  ----------------------------------------------------------------------*/
/*          This .W file was created with the Progress AppBuilder.      */
/*----------------------------------------------------------------------*/

/* ***************************  Definitions  ************************** */

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK 

/* ********************  Preprocessor Definitions  ******************** */



/* _UIB-PREPROCESSOR-BLOCK-END */
&ANALYZE-RESUME


/* ************************  Function Prototypes ********************** */

&IF DEFINED(EXCLUDE-getNodeHandle) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION-FORWARD getNodeHandle Method-Library 
FUNCTION getNodeHandle returns handle
(input pc-tag       as char,
 input ph-startNode as handle)  FORWARD.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-getTagValue) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION-FORWARD getTagValue Method-Library 
FUNCTION getTagValue returns character
( input pc-tag       as character,
  input ph-startNode as handle )  FORWARD.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-xmlEncode) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION-FORWARD xmlEncode Method-Library 
FUNCTION xmlEncode RETURNS CHARACTER
  (INPUT p_in AS CHARACTER) FORWARD.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF


/* *********************** Procedure Settings ************************ */

&ANALYZE-SUSPEND _PROCEDURE-SETTINGS
/* Settings for THIS-PROCEDURE
   Type: Method-Library
   Allow: 
   Frames: 0
   Add Fields to: Neither
   Other Settings: INCLUDE-ONLY
 */
&ANALYZE-RESUME _END-PROCEDURE-SETTINGS

/* *************************  Create Window  ************************** */

&ANALYZE-SUSPEND _CREATE-WINDOW
/* DESIGN Window definition (used by the UIB) 
  CREATE WINDOW Method-Library ASSIGN
         HEIGHT             = 7.29
         WIDTH              = 58.4.
/* END WINDOW DEFINITION */
                                                                        */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _INCLUDED-LIB Method-Library 
/* ************************* Included-Libraries *********************** */

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


 


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK Method-Library 


/* ***************************  Main Block  *************************** */

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


/* ************************  Function Implementations ***************** */

&IF DEFINED(EXCLUDE-getNodeHandle) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION getNodeHandle Method-Library 
FUNCTION getNodeHandle returns handle
(input pc-tag       as char,
 input ph-startNode as handle) :
/*------------------------------------------------------------------------------
  Purpose:  
    Notes:  
------------------------------------------------------------------------------*/

  define variable li-idx           as integer                           no-undo.  
  define variable li-jdx           as integer                           no-undo.  

  define variable lh-nextNode      as handle                            no-undo.
  define variable lh-rc            as handle                            no-undo.

  create x-noderef lh-nextNode.
 
  MAIN:
  do li-idx = 1 to ph-startNode:num-children:
    
      if ph-startNode:get-child(lh-nextNode,li-idx) and lh-nextNode:subtype = "ELEMENT":U then
      do:
         if lh-nextNode:name = pc-tag then
         do:
             lh-rc = lh-nextNode.
             leave MAIN.
         end.
         else
         do:
             lh-rc = getNodeHandle(pc-tag,lh-nextNode).
             if valid-handle(lh-rc) then leave MAIN.
         end.         
      end.
  end. /* ..of MAIN */

  return lh-rc.

END FUNCTION.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-getTagValue) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION getTagValue Method-Library 
FUNCTION getTagValue returns character
( input pc-tag       as character,
  input ph-startNode as handle ) :
/*------------------------------------------------------------------------------
  Purpose:  
    Notes:  
------------------------------------------------------------------------------*/

  define variable li-idx           as integer                           no-undo.  
  define variable li-jdx           as integer                           no-undo.  

  define variable lh-nextNode      as handle                            no-undo.
  define variable lh-leafNode      as handle                            no-undo.
  define variable lc-rc            as character                         no-undo.

  create x-noderef lh-nextNode.
 
  MAIN:
  do li-idx = 1 to ph-startNode:num-children:
    
      if ph-startNode:get-child(lh-nextNode,li-idx) and lh-nextNode:subtype = "ELEMENT":U then
      do:
         if lh-nextNode:name = pc-tag then
         do:
             create x-noderef lh-leafNode.

             do li-jdx = 1 to lh-nextNode:num-children:

                 if lh-nextNode:get-child(lh-leafNode,li-jdx) and lh-leafNode:subtype = "text":U then
                 do:
                     lc-rc = lh-leafNode:node-value.
                     leave MAIN.
                 end.
             end.
         end.
         else
         do:
             lc-rc = getTagValue(pc-tag,lh-nextNode).
             if lc-rc ne "":U then leave MAIN.
         end.         
      end.
  end. /* ..of MAIN */

  if valid-handle(lh-leafNode) then
  delete object lh-leafNode.

  delete object lh-nextNode.

  return lc-rc.

END FUNCTION.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-xmlEncode) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION xmlEncode Method-Library 
FUNCTION xmlEncode RETURNS CHARACTER
  (INPUT p_in AS CHARACTER):
/****************************************************************************
Description: Converts various ASCII characters to their HTML representation
  to prevent problems with invalid HTML.  This procedure can only be called
  once on a string or ampersands will incorrectly be replaced with "&amp; .
Input Parameter: Character string to encode
Returns: Encoded character string
****************************************************************************/
  /* Ampersand must be replaced first or the output will be hosed if done
     after any of these other subsititutions. */
  ASSIGN
    p_in = REPLACE(p_in, "&":U, "&amp~;":U)       /* ampersand */
    p_in = REPLACE(p_in, "~"":U, "&quot~;":U)     /* quote */
    p_in = REPLACE(p_in, "<":U, "&lt~;":U)        /* < */
    p_in = REPLACE(p_in, ">":U, "&gt~;":U).       /* > */
  RETURN p_in.

END FUNCTION. /* html-encode */

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

